// CodeGear C++Builder
// Copyright (c) 1995, 2010 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMRPars.pas' rev: 22.00

#ifndef SmrparsHPP
#define SmrparsHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <DB.hpp>	// Pascal unit
#include <SMRTypes.hpp>	// Pascal unit
#include <SMRDMan.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Smrpars
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum SMCANOp { canNOTDEFINED, canISBLANK, canNOTBLANK, canEQ, canNE, canGT, canLT, canGE, canLE, canNOT, canAND, canOR, canFIELD2, canCONST2, canMINUS, canADD, canSUB, canMUL, canDIV, canMOD, canSUM, canCOUNT, canMIN, canMAX, canAVG, canLIKE, canIN, canFUNC2, canLISTELEM2, canASSIGN };
#pragma option pop

typedef SMCANOp *PSMCANOp;

#pragma option push -b-
enum SMNODEClass { nodeNULL, nodeUNARY, nodeBINARY, nodeCOMPARE, nodeFIELD, nodeCONST, nodeLIST, nodeFUNC, nodeLISTELEM };
#pragma option pop

struct SMCANExpr;
typedef SMCANExpr *PSMCANExpr;

typedef PSMCANExpr *PPSMCANExpr;

#pragma pack(push,1)
struct DECLSPEC_DRECORD SMCANExpr
{
	
public:
	System::Word iVer;
	System::Word iTotalSize;
	System::Word iNodes;
	System::Word iNodeStart;
	System::Word iLiteralStart;
};
#pragma pack(pop)


#pragma pack(push,1)
struct DECLSPEC_DRECORD SMCANHdr
{
	
public:
	SMNODEClass nodeClass;
	SMCANOp canOp;
};
#pragma pack(pop)


typedef SMCANHdr *PSMCANHdr;

#pragma option push -b-
enum TExprNodeKind { enField, enConst, enOperator, enFunc };
#pragma option pop

#pragma option push -b-
enum TExprScopeKind { skField, skAgg, skConst };
#pragma option pop

struct TExprNode;
typedef TExprNode *PExprNode;

struct DECLSPEC_DRECORD TExprNode
{
	
public:
	TExprNode *FNext;
	TExprNodeKind FKind;
	bool FPartial;
	SMCANOp FOperator;
	System::Variant FData;
	TExprNode *FLeft;
	TExprNode *FRight;
	int FDataType;
	int FDataSize;
	Classes::TList* FArgs;
	TExprScopeKind FScopeKind;
};


typedef void __fastcall (__closure *TGetVariableEvent)(System::TObject* Sender, System::UnicodeString VariableName, bool &Accept, Db::TFieldType &VariableType, System::Variant &Value);

class DELPHICLASS TFilterExpr;
class PASCALIMPLEMENTATION TFilterExpr : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	TGetVariableEvent FVariableEvent;
	Smrdman::TSMRDataManager* FDataManager;
	Db::TFilterOptions FOptions;
	TExprNode *FNodes;
	SMCANExpr *FExprBuffer;
	int FExprBufSize;
	int FExprNodeSize;
	int FExprDataSize;
	Db::TField* __fastcall FieldFromNode(PExprNode Node);
	System::WideChar * __fastcall GetExprData(int Pos, int Size);
	int __fastcall PutConstBCD(const System::Variant &Value, int Decimals);
	int __fastcall PutConstBool(const System::Variant &Value);
	int __fastcall PutConstDate(const System::Variant &Value);
	int __fastcall PutConstDateTime(const System::Variant &Value);
	int __fastcall PutConstFloat(const System::Variant &Value);
	int __fastcall PutConstInt(int DataType, const System::Variant &Value);
	int __fastcall PutConstNode(int DataType, System::WideChar * Data, int Size);
	int __fastcall PutConstStr(const System::UnicodeString Value);
	int __fastcall PutConstTime(const System::Variant &Value);
	int __fastcall PutData(System::WideChar * Data, int Size);
	int __fastcall PutExprNode(PExprNode Node, SMCANOp ParentOp);
	int __fastcall PutFieldNode(Db::TField* Field, PExprNode Node);
	int __fastcall PutNode(SMNODEClass NodeType, SMCANOp OpType, int OpCount);
	void __fastcall SetNodeOp(int Node, int Index, int Data);
	int __fastcall PutConstant(PExprNode Node);
	
public:
	__fastcall TFilterExpr(Smrdman::TSMRDataManager* ADataManager, Db::TFilterOptions Options, TGetVariableEvent AGetVariableEvent);
	__fastcall virtual ~TFilterExpr(void);
	PExprNode __fastcall NewCompareNode(Db::TField* Field, SMCANOp Operator, const System::Variant &Value);
	PExprNode __fastcall NewNode(TExprNodeKind Kind, SMCANOp Operator, const System::Variant &Data, PExprNode Left, PExprNode Right);
	PSMCANExpr __fastcall GetFilterData(PExprNode Root);
	__property Smrdman::TSMRDataManager* DataManager = {write=FDataManager};
};


#pragma option push -b-
enum TExprToken { etEnd, etSymbol, etName, etLiteral, etLParen, etRParen, etEQ, etNE, etGE, etLE, etGT, etLT, etADD, etSUB, etMUL, etDIV, etComma, etLIKE, etISNULL, etISNOTNULL, etIN };
#pragma option pop

class DELPHICLASS TExprParser;
class PASCALIMPLEMENTATION TExprParser : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	TFilterExpr* FFilter;
	System::UnicodeString FText;
	System::WideChar *FSourcePtr;
	System::WideChar *FTokenPtr;
	System::UnicodeString FTokenString;
	System::UnicodeString FStrTrue;
	System::UnicodeString FStrFalse;
	TExprToken FToken;
	TExprToken FPrevToken;
	SMCANExpr *FFilterData;
	bool FNumericLit;
	int FDataSize;
	Smrdman::TSMRDataManager* FDataManager;
	void __fastcall NextToken(void);
	bool __fastcall NextTokenIsLParen(void);
	PExprNode __fastcall ParseExpr(void);
	PExprNode __fastcall ParseExpr2(void);
	PExprNode __fastcall ParseExpr3(void);
	PExprNode __fastcall ParseExpr4(void);
	PExprNode __fastcall ParseExpr5(void);
	PExprNode __fastcall ParseExpr6(void);
	PExprNode __fastcall ParseExpr7(void);
	System::UnicodeString __fastcall TokenName(void);
	bool __fastcall TokenSymbolIs(const System::UnicodeString S);
	bool __fastcall TokenSymbolIsFunc(const System::UnicodeString S);
	void __fastcall GetFuncResultInfo(PExprNode Node);
	void __fastcall TypeCheckArithOp(PExprNode Node);
	void __fastcall GetScopeKind(PExprNode Root, PExprNode Left, PExprNode Right);
	System::Variant __fastcall EvalNode(PExprNode Node);
	
public:
	__fastcall TExprParser(Smrdman::TSMRDataManager* ADataManager, const System::UnicodeString Text, Db::TFilterOptions Options, TGetVariableEvent AGetVariableEvent);
	__fastcall virtual ~TExprParser(void);
	void __fastcall SetExprParams(const System::UnicodeString Text);
	System::Variant __fastcall Evaluate(void);
};


struct FMTBcd;
typedef FMTBcd *PFMTBcd;

#pragma pack(push,1)
struct DECLSPEC_DRECORD FMTBcd
{
	
public:
	System::Byte iPrecision;
	System::Byte iSignSpecialPlaces;
	System::StaticArray<System::Byte, 32> iFraction;
};
#pragma pack(pop)


//-- var, const, procedure ---------------------------------------------------
static const System::ShortInt fldUNKNOWN = 0x0;
static const System::ShortInt fldZSTRING = 0x1;
static const System::ShortInt fldDATE = 0x2;
static const System::ShortInt fldBLOB = 0x3;
static const System::ShortInt fldBOOL = 0x4;
static const System::ShortInt fldINT16 = 0x5;
static const System::ShortInt fldINT32 = 0x6;
static const System::ShortInt fldFLOAT = 0x7;
static const System::ShortInt fldBCD = 0x8;
static const System::ShortInt fldBYTES = 0x9;
static const System::ShortInt fldTIME = 0xa;
static const System::ShortInt fldTIMESTAMP = 0xb;
static const System::ShortInt fldUINT16 = 0xc;
static const System::ShortInt fldUINT32 = 0xd;
static const System::ShortInt fldFLOATIEEE = 0xe;
static const System::ShortInt fldVARBYTES = 0xf;
static const System::ShortInt fldLOCKINFO = 0x10;
static const System::ShortInt fldCURSOR = 0x11;
static const System::ShortInt fldINT64 = 0x12;
static const System::ShortInt fldUINT64 = 0x13;
static const System::ShortInt fldADT = 0x14;
static const System::ShortInt fldARRAY = 0x15;
static const System::ShortInt fldREF = 0x16;
static const System::ShortInt fldTABLE = 0x17;
static const System::ShortInt fldDATETIME = 0x18;
static const System::ShortInt fldFMTBCD = 0x19;
static const System::ShortInt fldWIDESTRING = 0x1a;
static const System::ShortInt fldstORATIMESTAMP = 0x27;
static const System::ShortInt fldstORAINTERVAL = 0x28;
static const System::ShortInt fldSINGLE = 0x1b;
static const System::ShortInt fldDATETIMEOFFSET = 0x24;
static const System::ShortInt CANEXPRVERSION = 0x2;
extern PACKAGE System::StaticArray<System::Byte, 52> FldTypeMap;
extern PACKAGE Db::TField* __fastcall GetFieldByName(Smrdman::TSMRDataManager* DataManager, System::UnicodeString strName);
extern PACKAGE System::Variant __fastcall EvaluateValue(Smrdman::TSMRDataManager* DataManager, System::UnicodeString Expression, TGetVariableEvent AGetVariableEvent);
extern PACKAGE bool __fastcall ValueIsField(Smrdman::TSMRDataManager* DataManager, const System::UnicodeString Expression, TGetVariableEvent AGetVariableEvent);
extern PACKAGE System::Variant __fastcall GetCalculatedValue(Smrdman::TSMRDataManager* DataManager, const System::UnicodeString Expression, const System::UnicodeString Format, Smrtypes::TCalcType CalcType, const System::Variant &PrevValue, const System::Variant &CurValue, TGetVariableEvent AGetVariableEvent);

}	/* namespace Smrpars */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE)
using namespace Smrpars;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SmrparsHPP
