// CodeGear C++Builder
// Copyright (c) 1995, 2010 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMRTypes.pas' rev: 22.00

#ifndef SmrtypesHPP
#define SmrtypesHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Smrtypes
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TCalcType { ctNothing, ctCount, ctSum, ctAverage, ctLowest, ctHighest };
#pragma option pop

#pragma option push -b-
enum TResetType { rtEndReport, rtEndPage, rtEndGroup };
#pragma option pop

#pragma option push -b-
enum TSMRCalculate { rcOnEveryRow, rcGroupChange, rcVariableChange };
#pragma option pop

class DELPHICLASS TSMRCalculation;
class PASCALIMPLEMENTATION TSMRCalculation : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	System::UnicodeString FResetGroup;
	TCalcType FCalcType;
	TResetType FResetType;
	TSMRCalculate FCalculate;
	System::UnicodeString FGroupChange;
	System::UnicodeString FVariableChange;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	bool __fastcall StateChanged(const System::UnicodeString AGroupChanged, const System::UnicodeString AVariableChanged);
	
__published:
	__property System::UnicodeString ResetGroup = {read=FResetGroup, write=FResetGroup};
	__property TResetType ResetType = {read=FResetType, write=FResetType, nodefault};
	__property TCalcType CalcType = {read=FCalcType, write=FCalcType, nodefault};
	__property TSMRCalculate Calculate = {read=FCalculate, write=FCalculate, default=0};
	__property System::UnicodeString GroupChange = {read=FGroupChange, write=FGroupChange};
	__property System::UnicodeString VariableChange = {read=FVariableChange, write=FVariableChange};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSMRCalculation(void) { }
	
public:
	/* TObject.Create */ inline __fastcall TSMRCalculation(void) : Classes::TPersistent() { }
	
};


class DELPHICLASS TSMRHighLight;
class PASCALIMPLEMENTATION TSMRHighLight : public Classes::TCollectionItem
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::UnicodeString FExpression;
	Graphics::TFont* FFont;
	Graphics::TColor FColor;
	void __fastcall SetFont(Graphics::TFont* Value);
	
public:
	__fastcall virtual TSMRHighLight(Classes::TCollection* Collection);
	__fastcall virtual ~TSMRHighLight(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property System::UnicodeString Expression = {read=FExpression, write=FExpression};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property Graphics::TColor Color = {read=FColor, write=FColor, nodefault};
};


class DELPHICLASS TSMRHighLights;
class PASCALIMPLEMENTATION TSMRHighLights : public Classes::TCollection
{
	typedef Classes::TCollection inherited;
	
public:
	TSMRHighLight* operator[](int Index) { return Items[Index]; }
	
private:
	Classes::TComponent* FSMRControl;
	TSMRHighLight* __fastcall GetHighLight(int Index);
	void __fastcall SetHighLight(int Index, TSMRHighLight* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	__fastcall TSMRHighLights(Classes::TComponent* SMRCntrl);
	HIDESBASE TSMRHighLight* __fastcall Add(void);
	__property Classes::TComponent* SMRControl = {read=FSMRControl};
	__property TSMRHighLight* Items[int Index] = {read=GetHighLight, write=SetHighLight/*, default*/};
public:
	/* TCollection.Destroy */ inline __fastcall virtual ~TSMRHighLights(void) { }
	
};


class DELPHICLASS TSMRVariable;
class PASCALIMPLEMENTATION TSMRVariable : public Classes::TCollectionItem
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::UnicodeString FExpression;
	TSMRCalculation* FCalculation;
	System::UnicodeString FName;
	System::Variant FPrevValue;
	System::Variant FCurValue;
	TSMRCalculation* __fastcall GetCalculation(void);
	void __fastcall SetCalculation(TSMRCalculation* Value);
	
protected:
	bool __fastcall StorePrevValue(void);
	bool __fastcall StoreCurValue(void);
	
public:
	__fastcall virtual TSMRVariable(Classes::TCollection* Collection);
	__fastcall virtual ~TSMRVariable(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	bool __fastcall ValueChanged(void);
	
__published:
	__property System::UnicodeString Expression = {read=FExpression, write=FExpression};
	__property TSMRCalculation* Calculation = {read=GetCalculation, write=SetCalculation};
	__property System::UnicodeString Name = {read=FName, write=FName};
	__property System::Variant PrevValue = {read=FPrevValue, write=FPrevValue, stored=StorePrevValue};
	__property System::Variant CurValue = {read=FCurValue, write=FCurValue, stored=StoreCurValue};
};


class DELPHICLASS TSMRVariables;
class PASCALIMPLEMENTATION TSMRVariables : public Classes::TCollection
{
	typedef Classes::TCollection inherited;
	
public:
	TSMRVariable* operator[](int Index) { return Items[Index]; }
	
private:
	Classes::TComponent* FSMRControl;
	TSMRVariable* __fastcall GetVariable(int Index);
	void __fastcall SetVariable(int Index, TSMRVariable* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	__fastcall TSMRVariables(Classes::TComponent* SMRCntrl);
	HIDESBASE TSMRVariable* __fastcall Add(void);
	__property Classes::TComponent* SMRControl = {read=FSMRControl};
	__property TSMRVariable* Items[int Index] = {read=GetVariable, write=SetVariable/*, default*/};
public:
	/* TCollection.Destroy */ inline __fastcall virtual ~TSMRVariables(void) { }
	
};


#pragma option push -b-
enum TSMRParameterEditor { peEdit, peMemo, peCheckBox, peCombobox, peListBox };
#pragma option pop

#pragma option push -b-
enum TSMRParameterMode { pmAskAlways, pmAskUndefined };
#pragma option pop

class DELPHICLASS TSMRParameter;
class PASCALIMPLEMENTATION TSMRParameter : public Classes::TCollectionItem
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::UnicodeString FName;
	System::UnicodeString FDisplayLabel;
	System::Variant FValue;
	TSMRParameterEditor FParameterEditor;
	TSMRParameterMode FParameterMode;
	Classes::TStrings* FParamPromptValues;
	void __fastcall SetParamPromptValues(Classes::TStrings* Value);
	
public:
	__fastcall virtual TSMRParameter(Classes::TCollection* Collection);
	__fastcall virtual ~TSMRParameter(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property System::UnicodeString DisplayLabel = {read=FDisplayLabel, write=FDisplayLabel};
	__property System::UnicodeString Name = {read=FName, write=FName};
	__property System::Variant Value = {read=FValue, write=FValue};
	__property Classes::TStrings* ParamPromptValues = {read=FParamPromptValues, write=SetParamPromptValues};
	__property TSMRParameterEditor ParameterEditor = {read=FParameterEditor, write=FParameterEditor, default=0};
	__property TSMRParameterMode ParameterMode = {read=FParameterMode, write=FParameterMode, default=0};
};


class DELPHICLASS TSMRParameters;
class PASCALIMPLEMENTATION TSMRParameters : public Classes::TCollection
{
	typedef Classes::TCollection inherited;
	
public:
	TSMRParameter* operator[](int Index) { return Items[Index]; }
	
private:
	Classes::TComponent* FSMRControl;
	TSMRParameter* __fastcall GetParameter(int Index);
	void __fastcall SetParameter(int Index, TSMRParameter* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	__fastcall TSMRParameters(Classes::TComponent* SMRCntrl);
	HIDESBASE TSMRParameter* __fastcall Add(void);
	TSMRParameter* __fastcall ParamByName(const System::UnicodeString Value);
	__property Classes::TComponent* SMRControl = {read=FSMRControl};
	__property TSMRParameter* Items[int Index] = {read=GetParameter, write=SetParameter/*, default*/};
public:
	/* TCollection.Destroy */ inline __fastcall virtual ~TSMRParameters(void) { }
	
};


class DELPHICLASS TSMROutline;
class PASCALIMPLEMENTATION TSMROutline : public Classes::TCollectionItem
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::UnicodeString FText;
	int FPageNo;
	int FBarNo;
	int FTop;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property System::UnicodeString Text = {read=FText, write=FText};
	__property int PageNo = {read=FPageNo, write=FPageNo, nodefault};
	__property int BarNo = {read=FBarNo, write=FBarNo, nodefault};
	__property int Top = {read=FTop, write=FTop, nodefault};
public:
	/* TCollectionItem.Create */ inline __fastcall virtual TSMROutline(Classes::TCollection* Collection) : Classes::TCollectionItem(Collection) { }
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TSMROutline(void) { }
	
};


class DELPHICLASS TSMROutlines;
class PASCALIMPLEMENTATION TSMROutlines : public Classes::TCollection
{
	typedef Classes::TCollection inherited;
	
private:
	Classes::TComponent* FSMRControl;
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	__fastcall TSMROutlines(Classes::TComponent* SMRCntrl);
	HIDESBASE TSMROutline* __fastcall Add(void);
	__property Classes::TComponent* SMRControl = {read=FSMRControl};
public:
	/* TCollection.Destroy */ inline __fastcall virtual ~TSMROutlines(void) { }
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Smrtypes */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE)
using namespace Smrtypes;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SmrtypesHPP
